function varargout = XYStage_UI(varargin)
% XYSTAGE_UI MATLAB code for XYStage_UI.fig
%      XYSTAGE_UI, by itself, creates a new XYSTAGE_UI or raises the existing
%      singleton*.
%
%      H = XYSTAGE_UI returns the handle to a new XYSTAGE_UI or the handle to
%      the existing singleton*.
%
%      XYSTAGE_UI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in XYSTAGE_UI.M with the given input arguments.
%
%      XYSTAGE_UI('Property','Value',...) creates a new XYSTAGE_UI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before XYStage_UI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to XYStage_UI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help XYStage_UI

% Last Modified by GUIDE v2.5 23-May-2014 12:07:34

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @XYStage_UI_OpeningFcn, ...
                   'gui_OutputFcn',  @XYStage_UI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before XYStage_UI is made visible.
function XYStage_UI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to XYStage_UI (see VARARGIN)

% Choose default command line output for XYStage_UI
handles.output = hObject;
%ADD FIELDS IN handles WITH DEFAULT VALUES
handles.xy = 0;
handles.PortObj = NaN; %port object;
handles.COMPort = 'COM4';
handles.PortObjVar = 1; 
handles.ControllerType = 'EZHR17'; %supported: EZHR17
handles.ControllerTypeVar = 1;
handles.ControllerNameX = 3; %name or number of controller on this port
handles.ControllerNameXVar = 1;
handles.ControllerNameY = 4; %name or number of controller on this port
handles.ControllerNameYVar = 1;
handles.LeadUmX = 1000; % up/down travel for one full turn in microns; typically 100 um.
handles.LeadUmXVar = 1;
handles.LeadUmY = 1000; % up/down travel for one full turn in microns; typically 100 um.
handles.LeadUmYVar = 1;
handles.MotorStepsX = 200; %physical steps in the motor; typically 200
handles.MotorStepsXVar = 1;
handles.MotorStepsY = 200; %physical steps in the motor; typically 200
handles.MotorStepsYVar = 1;
handles.HoldCurrentX = 5; %current when not moving; in % of full (2A for EZHR17); typically 5%
handles.HoldCurrentXVar = 1;
handles.HoldCurrentY = 5; %current when not moving; in % of full (2A for EZHR17); typically 5%
handles.HoldCurrentYVar = 1;
handles.RunCurrentX = 50; %current when moving; in % of full (2A for EZHR17); typically 25%
handles.RunCurrentXVar = 1;
handles.RunCurrentY = 50; %current when moving; in % of full (2A for EZHR17); typically 25%
handles.RunCurrentYVar = 1;
handles.StepDivideX = 256; %number of microsteps per step; typically 256
handles.StepDivideXVar = 1;
handles.StepDivideY = 256; %number of microsteps per step; typically 256
handles.StepDivideYVar = 1;
handles.SlewVelocityX = 10000; %slew (max) velocity in microns/sec 
handles.SlewVelocityXVar = 1;
handles.SlewVelocityY = 10000; %slew (max) velocity in microns/sec 
handles.SlewVelocityYVar = 1;
handles.InitVelocityX = 500; %initial velocity in microns/sec 
handles.InitVelocityXVar = 1;
handles.InitVelocityY = 500; %initial velocity in microns/sec 
handles.InitVelocityYVar = 1;
handles.RampX = 100; %acceleration (deceleration) in microns/sec^2 
handles.RampXVar = 1;
handles.RampY = 100; %acceleration (deceleration) in microns/sec^2 
handles.RampYVar = 1;
handles.LimitPolarity = 0; %0 - normal polarity; 1 - inverted
handles.LimitPolarityVar = 1;
handles.WithLimits = 1; %1 - if has limits; 0 - without limits
handles.WithLimitsVar = 1;
handles.Log = 0; %0 - do not accumulate log; 1 - accumulate log
handles.LogVar = 1;

%READ PARAMETER VALUES
try
    load XYStage.mat;
    handles.COMPort = COMPort;
    handles.ControllerType = ControllerType;
    handles.ControllerNameX = ControllerNameX;
    handles.ControllerNameY = ControllerNameY;
    handles.LeadUmX = LeadUmX;
    handles.LeadUmY = LeadUmY;
    handles.MotorStepsX = MotorStepsX;
    handles.MotorStepsY = MotorStepsY;
    handles.HoldCurrentX = HoldCurrentX;
    handles.HoldCurrentY = HoldCurrentY;
    handles.RunCurrentX = RunCurrentX;
    handles.RunCurrentY = RunCurrentY;
    handles.StepDivideX = StepDivideX;
    handles.StepDivideY = StepDivideY;
    handles.SlewVelocityX = SlewVelocityX;
    handles.SlewVelocityY = SlewVelocityY;
    handles.InitVelocityX = InitVelocityX;
    handles.InitVelocityY = InitVelocityY;
    handles.RampX = RampX;
    handles.RampY = RampY;
    handles.LimitPolarity = LimitPolarity;
    if(exist('WithLimits','var')), handles.WithLimits = WithLimits; end
    handles.Log = Log;
    set(handles.txtMessage,'String','Parameters read'); 
catch ME
   set(handles.txtMessage,'String','Parameter file was not read; using defaults'); 
end

%PARSE INPUT LINE
property_argin = varargin;
while (length(property_argin) >= 2)
    prop = property_argin{1};
    val = property_argin{2};
    property_argin = property_argin(3:end);
    switch prop
    case 'PortObj'
        handles.PortObj = val; handles.PortObjVar = 0; 
    case 'ControllerType'
        handles.ControllerType = val; handles.ControllerTypeVar = 0;
    case 'ControllerNameX'
        handles.ControllerNameX = val; handles.ControllerNameXVar = 0;
    case 'ControllerNameY'
        handles.ControllerNameY = val; handles.ControllerNameYVar = 0;
    case 'LeadUmX'
        handles.LeadUmX = val; handles.LeadUmXVar = 0;
    case 'LeadUmY'
        handles.LeadUmY = val; handles.LeadUmYVar = 0;
    case 'MotorStepsX'
        handles.MotorStepsX = val; handles.MotorStepsXVar = 0;
    case 'MotorStepsY'
        handles.MotorStepsY = val; handles.MotorStepsYVar = 0;
    case 'HoldCurrentX'
        handles.HoldCurrentX = val; handles.HoldCurrentXVar = 0;
    case 'HoldCurrentY'
        handles.HoldCurrentY = val; handles.HoldCurrentYVar = 0;
    case 'RunCurrentX'
        handles.RunCurrentX = val; handles.RunCurrentXVar = 0;
    case 'RunCurrentY'
        handles.RunCurrentY = val; handles.RunCurrentYVar = 0;
    case 'StepDivideX'
        handles.StepDivideX = val; handles.StepDivideXVar = 0;
    case 'StepDivideY'
        handles.StepDivideY = val; handles.StepDivideYVar = 0;
    case 'SlewVelocityX'
        handles.SlewVelocityX = val; handles.SlewVelocityXVar = 0;
    case 'SlewVelocityY'
        handles.SlewVelocityY = val; handles.SlewVelocityYVar = 0;
    case 'InitVelocityX'
        handles.InitVelocityX = val; handles.InitVelocityXVar = 0;
    case 'InitVelocityY'
        handles.InitVelocityY = val; handles.InitVelocityYVar = 0;
    case 'RampX'
        handles.RampX = val; handles.RampXVar = 0;
    case 'RampY'
        handles.RampY = val; handles.RampYVar = 0;
    case 'LimitPolarity'
        handles.LimitPolarity = val; handles.LimitPolarityVar = 0;
    case 'WithLimits'
        handles.WithLimits = val; handles.WithLimitsVar = 0;
    case 'Log'
        handles.Log = val; handles.LogVar = 0;
    end
end

%Form menu labels
if(handles.PortObjVar == 1)
    set(handles.mnuPort,'Label',['Port = ', handles.COMPort]);
else    
    s = handles.PortObj; 
    if(strcmp(class(s),'serial'))
        handles.COMPort = s.Port; 
    else
        handles.COMPort = 'not a serial port';
    end
    set(handles.mnuPort,'Label',['Port = ', handles.COMPort]);
    set(handles.mnuPort,'Enable','off');
    set(handles.mnuOpenCOM,'Enable','off');
    set(handles.mnuCreateXY,'Enable','on');
end    
set(handles.mnuControllerType,'Label', ['ControllerType = ' handles.ControllerType]);
if(handles.ControllerTypeVar == 0), set(handles.mnuControllerType,'Enable','off'); end

set(handles.mnuControllerNameX,'Label', ['ControllerNameX = ' num2str(handles.ControllerNameX)]);
if(handles.ControllerNameXVar == 0), set(handles.mnuControllerNameX,'Enable','off'); end
set(handles.mnuControllerNameY,'Label', ['ControllerNameY = ' num2str(handles.ControllerNameY)]);
if(handles.ControllerNameYVar == 0), set(handles.mnuControllerNameY,'Enable','off'); end

set(handles.mnuLeadUmX,'Label', ['LeadUmX = ' num2str(handles.LeadUmX)]);
if(handles.LeadUmXVar == 0), set(handles.mnuLeadUmX,'Enable','off'); end
set(handles.mnuLeadUmY,'Label', ['LeadUmY = ' num2str(handles.LeadUmY)]);
if(handles.LeadUmYVar == 0), set(handles.mnuLeadUmY,'Enable','off'); end

set(handles.mnuMotorStepsX,'Label', ['MotorStepsX = ' num2str(handles.MotorStepsX)]);
if(handles.MotorStepsXVar == 0), set(handles.mnuMotorStepsX,'Enable','off'); end
set(handles.mnuMotorStepsY,'Label', ['MotorStepsY = ' num2str(handles.MotorStepsY)]);
if(handles.MotorStepsYVar == 0), set(handles.mnuMotorStepsY,'Enable','off'); end

set(handles.mnuHoldCurrentX,'Label', ['HoldCurrentX = ' num2str(handles.HoldCurrentX)]);
if(handles.HoldCurrentXVar == 0), set(handles.mnuHoldCurrentX,'Enable','off'); end
set(handles.mnuHoldCurrentY,'Label', ['HoldCurrentY = ' num2str(handles.HoldCurrentY)]);
if(handles.HoldCurrentYVar == 0), set(handles.mnuHoldCurrentY,'Enable','off'); end

set(handles.mnuRunCurrentX,'Label', ['RunCurrentX = ' num2str(handles.RunCurrentX)]);
if(handles.RunCurrentXVar == 0), set(handles.mnuRunCurrentX,'Enable','off'); end
set(handles.mnuRunCurrentY,'Label', ['RunCurrentY = ' num2str(handles.RunCurrentY)]);
if(handles.RunCurrentYVar == 0), set(handles.mnuRunCurrentY,'Enable','off'); end

set(handles.mnuStepDivideX,'Label', ['StepDivideX = ' num2str(handles.StepDivideX)]);
if(handles.StepDivideXVar == 0), set(handles.mnuStepDivideX,'Enable','off'); end
set(handles.mnuStepDivideY,'Label', ['StepDivideY = ' num2str(handles.StepDivideY)]);
if(handles.StepDivideYVar == 0), set(handles.mnuStepDivideY,'Enable','off'); end

set(handles.mnuSlewVelocityX,'Label', ['SlewVelocityX = ' num2str(handles.SlewVelocityX)]);
if(handles.SlewVelocityXVar == 0), set(handles.mnuSlewVelocityX,'Enable','off'); end
set(handles.mnuSlewVelocityY,'Label', ['SlewVelocityY = ' num2str(handles.SlewVelocityY)]);
if(handles.SlewVelocityYVar == 0), set(handles.mnuSlewVelocityY,'Enable','off'); end

set(handles.mnuInitVelocityX,'Label', ['InitVelocityX = ' num2str(handles.InitVelocityX)]);
if(handles.InitVelocityXVar == 0), set(handles.mnuInitVelocityX,'Enable','off'); end
set(handles.mnuInitVelocityY,'Label', ['InitVelocityY = ' num2str(handles.InitVelocityY)]);
if(handles.InitVelocityYVar == 0), set(handles.mnuInitVelocityY,'Enable','off'); end

set(handles.mnuRampX,'Label', ['RampX = ' num2str(handles.RampX)]);
if(handles.RampXVar == 0), set(handles.mnuRampX,'Enable','off'); end
set(handles.mnuRampY,'Label', ['RampY = ' num2str(handles.RampY)]);
if(handles.RampYVar == 0), set(handles.mnuRampY,'Enable','off'); end

set(handles.mnuLimitPolarity,'Label', ['LimitPolarity = ' num2str(handles.LimitPolarity)]);
if(handles.LimitPolarityVar == 0), set(handles.mnuLimitPolarity,'Enable','off'); end

set(handles.mnuWithLimits,'Label', ['WithLimits = ' num2str(handles.WithLimits)]);
if(handles.WithLimitsVar == 0), set(handles.mnuWithLimits,'Enable','off'); end

set(handles.mnuLog,'Label', ['Log = ' num2str(handles.Log)]);
if(handles.LogVar == 0), set(handles.mnuLog,'Enable','off'); end

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes XYStage_UI wait for user response (see UIRESUME)
% uiwait(handles.figXYStage);


% --- Outputs from this function are returned to the command line.
function varargout = XYStage_UI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function mnuPar_Callback(hObject, eventdata, handles)
% hObject    handle to mnuPar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function mnuInit_Callback(hObject, eventdata, handles)
% hObject    handle to mnuInit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function mnuLL_Callback(hObject, eventdata, handles)
% hObject    handle to mnuLL (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function mnuViewLog_Callback(hObject, eventdata, handles)
% hObject    handle to mnuViewLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
log = EZStepperLog();
log


% --------------------------------------------------------------------
function mnuClearLog_Callback(hObject, eventdata, handles)
% hObject    handle to mnuClearLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
EZStepperClearLog;


% --------------------------------------------------------------------
function mnuOpenCOM_Callback(hObject, eventdata, handles)
% hObject    handle to mnuOpenCOM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[s,error] = EZStepperOpenSerial(handles.COMPort);
if(error==0)
    handles.PortObj = s;
    set(hObject,'Enable','off');
    set(handles.mnuPort,'Enable','off');
    set(handles.mnuCreateXY,'Enable','on');
end
msg = ['Open Port ' handles.COMPort ', error = ' num2str(error)];
set(handles.txtMessage,'String',msg);
guidata(hObject,handles); % store the changes


% --------------------------------------------------------------------
function mnuCreateXY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuCreateXY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%SAVE PARAMETERS
COMPort = handles.COMPort;
ControllerType = handles.ControllerType;
ControllerNameX = handles.ControllerNameX;
ControllerNameY = handles.ControllerNameY;
LeadUmX = handles.LeadUmX;
LeadUmY = handles.LeadUmY;
MotorStepsX = handles.MotorStepsX;
MotorStepsY = handles.MotorStepsY;
HoldCurrentX = handles.HoldCurrentX;
HoldCurrentY = handles.HoldCurrentY;
RunCurrentX = handles.RunCurrentX;
RunCurrentY = handles.RunCurrentY;
StepDivideX = handles.StepDivideX;
StepDivideY = handles.StepDivideY;
SlewVelocityX = handles.SlewVelocityX;
SlewVelocityY = handles.SlewVelocityY;
InitVelocityX = handles.InitVelocityX;
InitVelocityY = handles.InitVelocityY;
RampX = handles.RampX;
RampY = handles.RampY;
LimitPolarity = handles.LimitPolarity;
WithLimits = handles.WithLimits;
Log = handles.Log;

%CREATE OBJECT
try
    xy = XYStage('PortObj', handles.PortObj, ...
        'ControllerNameX', ControllerNameX, 'ControllerNameY', ControllerNameY, ...
        'LeadUmX', LeadUmX, 'LeadUmY', LeadUmY, ...
        'MotorStepsX', MotorStepsX, 'MotorStepsY', MotorStepsY, ...
        'HoldCurrentX', HoldCurrentX, 'HoldCurrentY', HoldCurrentY, ...
        'RunCurrentX', RunCurrentX, 'RunCurrentY', RunCurrentY, ...
        'StepDivideX', StepDivideX, 'StepDivideY', StepDivideY, ...
        'SlewVelocityX', SlewVelocityX, 'SlewVelocityY', SlewVelocityY, ...
        'InitVelocityX', InitVelocityX, 'InitVelocityY', InitVelocityY, ...
        'RampX', RampX, 'RampY', RampY, ...
        'LimitPolarity', LimitPolarity, 'WithLimits', WithLimits, 'Log', Log);
    handles.xy = xy;
    errx= get(xy,'LastErrX');
    erry= get(xy,'LastErrY');
catch ER
    errx = -99; erry = -99; 
end
if((errx==0)&&(erry==0))
    
    save XYStage.mat COMPort ControllerType ...
    ControllerNameX ControllerNameY ...
    LeadUmX LeadUmY ...
    MotorStepsX MotorStepsY ...
    HoldCurrentX HoldCurrentY ...
    RunCurrentX RunCurrentY ...
    StepDivideX StepDivideY ...
    SlewVelocityX SlewVelocityY  ...
    InitVelocityX InitVelocityY ...
    RampX RampY ...
    LimitPolarity WithLimits Log;

    msg = ['XY Object Created, LastErrX = ' num2str(errx) ', LastErrY = ' num2str(erry)];
    set(handles.txtMessage,'String',msg);
    set(hObject,'Enable','off');
    guidata(hObject,handles); % store the changes
    %ENABLE ACTION BUTTONS
    set(handles.btnHome,'Enable','on');
    set(handles.btnHomeComplete,'Enable','on');
    set(handles.btnHome2Phase,'Enable','on');
    set(handles.btnReadPos,'Enable','on');
    set(handles.btnSetOrigin,'Enable','on');
    set(handles.btnMoveAbs,'Enable','on');
    set(handles.btnMoveRel,'Enable','on');
    set(handles.btnJog,'Enable','on');
    set(handles.btnStop,'Enable','on'); 
    set(handles.btnToLimitX,'Enable','on');
    set(handles.btnToLimitY,'Enable','on');
    set(handles.btnExecuteX,'Enable','on');
    set(handles.btnExecuteY,'Enable','on');
    
    
    %DISABLE CHANGING PARAMETERS THAT SHOULD NOT CHANGE AFTER OBJECT CREATION
    set(handles.mnuControllerType,'Enable','off');
    set(handles.mnuControllerNameX,'Enable','off');
    set(handles.mnuControllerNameY,'Enable','off');
    set(handles.mnuLeadUmX,'Enable','off');
    set(handles.mnuLeadUmY,'Enable','off');
    set(handles.mnuMotorStepsX,'Enable','off');
    set(handles.mnuMotorStepsY,'Enable','off');
    set(handles.mnuLimitPolarity,'Enable','off');
else
    msg = ['Error creating XY Obj., LastErrX = ' num2str(errx) ', LastErrY = ' num2str(erry)];
    set(handles.txtMessage,'String',msg);    
end


% --------------------------------------------------------------------
function mnuPort_Callback(hObject, eventdata, handles)
% hObject    handle to mnuPort (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
newc = inputdlg('Enter new value for COM Port','Port',1,{handles.COMPort});
drawnow;
if(~isempty(newc)) 
    handles.COMPort = newc{1}; 
    msg = ['Port = ', handles.COMPort];
    set(handles.mnuPort,'Label',msg);
    set(handles.txtMessage,'String',msg); 
    guidata(hObject, handles);
end


% --------------------------------------------------------------------
function mnuControllerType_Callback(hObject, eventdata, handles)
% hObject    handle to mnuControllerType (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function mnuControllerNameX_Callback(hObject, eventdata, handles)
% hObject    handle to mnuControllerNameX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for ControllerNameX (Number)','ControllerNameX',1,{num2str(handles.ControllerNameX)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.ControllerNameX = newv; 
        msg = ['ControllerNameX = ', num2str(handles.ControllerNameX)];
        set(handles.mnuControllerNameX,'Label',msg);
        set(handles.txtMessage,'String',msg);
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuControllerNameY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuControllerNameY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for ControllerNameY (Number)','ControllerNameY',1,{num2str(handles.ControllerNameY)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.ControllerNameY = newv; 
        msg = ['ControllerNameY = ', num2str(handles.ControllerNameY)];
        set(handles.mnuControllerNameY,'Label',msg);
        set(handles.txtMessage,'String',msg);
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuLeadUmX_Callback(hObject, eventdata, handles)
% hObject    handle to mnuLeadUmX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for LeadUmX','LeadUmX',1,{num2str(handles.LeadUmX)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.LeadUmX = newv; 
        msg = ['LeadUmX = ', num2str(handles.LeadUmX)];
        set(handles.mnuLeadUmX,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuLeadUmY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuLeadUmY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for LeadUmY','LeadUmY',1,{num2str(handles.LeadUmY)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.LeadUmY = newv; 
        msg = ['LeadUmY = ', num2str(handles.LeadUmY)];
        set(handles.mnuLeadUmY,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuMotorStepsX_Callback(hObject, eventdata, handles)
% hObject    handle to mnuMotorStepsX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for MotorStepsX','MotorStepsX',1,{num2str(handles.MotorStepsX)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.MotorStepsX = newv; 
        msg = ['MotorStepsX = ', num2str(handles.MotorStepsX)];
        set(handles.mnuMotorStepsX,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuMotorStepsY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuMotorStepsY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for MotorStepsY','MotorStepsY',1,{num2str(handles.MotorStepsY)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.MotorStepsY = newv; 
        msg = ['MotorStepsY = ', num2str(handles.MotorStepsY)];
        set(handles.mnuMotorStepsY,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuLimitPolarity_Callback(hObject, eventdata, handles)
% hObject    handle to mnuLimitPolarity (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for LimitPolarity','LimitPolarity',1,{num2str(handles.LimitPolarity)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.LimitPolarity = newv; 
        msg = ['LimitPolarity = ', num2str(handles.LimitPolarity)];
        set(handles.mnuLimitPolarity,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end

% --------------------------------------------------------------------
function mnuWithLimits_Callback(hObject, eventdata, handles)
% hObject    handle to mnuWithLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for WithLimits','WithLimits',1,{num2str(handles.WithLimits)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.WithLimits = newv; 
        msg = ['WithLimits = ', num2str(handles.WithLimits)];
        set(handles.mnuWithLimits,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuHoldCurrentX_Callback(hObject, eventdata, handles)
% hObject    handle to mnuHoldCurrentX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for HoldCurrentX','HoldCurrentX',1,{num2str(handles.HoldCurrentX)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.HoldCurrentX = newv; 
        msg = ['HoldCurrentX = ', num2str(handles.HoldCurrentX)];
        set(handles.mnuHoldCurrentX,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'HoldCurrentX',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuHoldCurrentY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuHoldCurrentY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for HoldCurrentY','HoldCurrentY',1,{num2str(handles.HoldCurrentY)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.HoldCurrentY = newv; 
        msg = ['HoldCurrentY = ', num2str(handles.HoldCurrentY)];
        set(handles.mnuHoldCurrentY,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'HoldCurrentY',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuRunCurrentX_Callback(hObject, eventdata, handles)
% hObject    handle to mnuRunCurrentX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for RunCurrentX','RunCurrentX',1,{num2str(handles.RunCurrentX)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.RunCurrentX = newv; 
        msg = ['RunCurrentX = ', num2str(handles.RunCurrentX)];
        set(handles.mnuRunCurrentX,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'RunCurrentX',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuRunCurrentY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuRunCurrentY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for RunCurrentY','RunCurrentY',1,{num2str(handles.RunCurrentY)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.RunCurrentY = newv; 
        msg = ['RunCurrentY = ', num2str(handles.RunCurrentY)];
        set(handles.mnuRunCurrentY,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'RunCurrentY',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuStepDivideX_Callback(hObject, eventdata, handles)
% hObject    handle to mnuStepDivideX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for StepDivideX','StepDivideX',1,{num2str(handles.StepDivideX)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.StepDivideX = newv; 
        msg = ['StepDivideX = ', num2str(handles.StepDivideX)];
        set(handles.mnuStepDivideX,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'StepDivideX',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuStepDivideY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuStepDivideY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for StepDivideY','StepDivideY',1,{num2str(handles.StepDivideY)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.StepDivideY = newv; 
        msg = ['StepDivideY = ', num2str(handles.StepDivideY)];
        set(handles.mnuStepDivideY,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'StepDivideY',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuSlewVelocityX_Callback(hObject, eventdata, handles)
% hObject    handle to mnuSlewVelocityX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for SlewVelocityX','SlewVelocityX',1,{num2str(handles.SlewVelocityX)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.SlewVelocityX = newv; 
        msg = ['SlewVelocityX = ', num2str(handles.SlewVelocityX)];
        set(handles.mnuSlewVelocityX,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'SlewVelocityX',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuSlewVelocityY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuSlewVelocityY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for SlewVelocityY','SlewVelocityY',1,{num2str(handles.SlewVelocityY)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.SlewVelocityY = newv; 
        msg = ['SlewVelocityY = ', num2str(handles.SlewVelocityY)];
        set(handles.mnuSlewVelocityY,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'SlewVelocityY',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuInitVelocityX_Callback(hObject, eventdata, handles)
% hObject    handle to mnuInitVelocityX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for InitVelocityX','InitVelocityX',1,{num2str(handles.InitVelocityX)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.InitVelocityX = newv; 
        msg = ['InitVelocityX = ', num2str(handles.InitVelocityX)];
        set(handles.mnuInitVelocityX,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'InitVelocityX',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuInitVelocityY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuInitVelocityY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for InitVelocityY','InitVelocityY',1,{num2str(handles.InitVelocityY)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.InitVelocityY = newv; 
        msg = ['InitVelocityY = ', num2str(handles.InitVelocityY)];
        set(handles.mnuInitVelocityY,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'InitVelocityY',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuRampX_Callback(hObject, eventdata, handles)
% hObject    handle to mnuRampX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for RampX','RampX',1,{num2str(handles.RampX)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.RampX = newv; 
        msg = ['RampX = ', num2str(handles.RampX)];
        set(handles.mnuRampX,'Label',msg);
        set(handles.txtMessage,'String',msg);
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'RampX',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuRampY_Callback(hObject, eventdata, handles)
% hObject    handle to mnuRampY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for RampY','RampY',1,{num2str(handles.RampY)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.RampY = newv; 
        msg = ['RampY = ', num2str(handles.RampY)];
        set(handles.mnuRampY,'Label',msg);
        set(handles.txtMessage,'String',msg);
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'RampY',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuLog_Callback(hObject, eventdata, handles)
% hObject    handle to mnuLog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
answ = inputdlg('Enter new value for Log','Log',1,{num2str(handles.Log)});
drawnow;
if(~isempty(answ)) 
    news = answ{1};
    newv = str2double(news);
    if(isnan(newv))
        set(handles.txtMessage,'String','Not a number'); 
    else
        handles.Log = newv; 
        msg = ['Log = ', num2str(handles.Log)];
        set(handles.mnuLog,'Label',msg);
        set(handles.txtMessage,'String',msg); 
        xy = handles.xy;
        if(strcmp(class(xy),'XYStage')) 
           set(xy,'Log',newv);
        end
        guidata(hObject, handles);      
    end
end


% --------------------------------------------------------------------
function mnuSavePar_Callback(hObject, eventdata, handles)
% hObject    handle to mnuSavePar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
COMPort = handles.COMPort;
ControllerType = handles.ControllerType;
ControllerNameX = handles.ControllerNameX;
ControllerNameY = handles.ControllerNameY;
LeadUmX = handles.LeadUmX;
LeadUmY = handles.LeadUmY;
MotorStepsX = handles.MotorStepsX;
MotorStepsY = handles.MotorStepsY;
HoldCurrentX = handles.HoldCurrentX;
HoldCurrentY = handles.HoldCurrentY;
RunCurrentX = handles.RunCurrentX;
RunCurrentY = handles.RunCurrentY;
StepDivideX = handles.StepDivideX;
StepDivideY = handles.StepDivideY;
SlewVelocityX = handles.SlewVelocityX;
SlewVelocityY = handles.SlewVelocityY;
InitVelocityX = handles.InitVelocityX;
InitVelocityY = handles.InitVelocityY;
RampX = handles.RampX;
RampY = handles.RampY;
LimitPolarity = handles.LimitPolarity;
WithLimits = handles.WithLimits;
Log = handles.Log;

save XYStage.mat COMPort ControllerType ...
    ControllerNameX ControllerNameY ...
    LeadUmX LeadUmY ...
    MotorStepsX MotorStepsY ...
    HoldCurrentX HoldCurrentY ...
    RunCurrentX RunCurrentY ...
    StepDivideX StepDivideY ...
    SlewVelocityX SlewVelocityY  ...
    InitVelocityX InitVelocityY ...
    RampX RampY ...
    LimitPolarity WithLimits Log;

% --- Executes on button press in btnHome.
function btnHome_Callback(hObject, eventdata, handles)
% hObject    handle to btnHome (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
err = XYHome(xy);
set(handles.txtMessage,'String',['Home started, error = ' num2str(err)]);


% --- Executes on button press in btnHomeComplete.
function btnHomeComplete_Callback(hObject, eventdata, handles)
% hObject    handle to btnHomeComplete (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
set(handles.txtMessage,'String','Homing ...');
drawnow
err = XYHomeComplete(xy);
set(handles.txtMessage,'String',['Home finished, error = ' num2str(err)]);


% --- Executes on button press in btnHome2Phase.
function btnHome2Phase_Callback(hObject, eventdata, handles)
% hObject    handle to btnHome2Phase (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
set(handles.txtMessage,'String','Homing ...');
drawnow
err = XYHome2Phase(xy);
set(handles.txtMessage,'String',['Home finished, error = ' num2str(err)]);


% --- Executes on button press in btnMoveAbs.
function btnMoveAbs_Callback(hObject, eventdata, handles)
% hObject    handle to btnMoveAbs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
destinationx = str2double(get(handles.txtMoveAbsX,'String'));
if isnan(destinationx), set(handles.txtMessage,'String','X destination is not a number'); return; end
destinationy = str2double(get(handles.txtMoveAbsY,'String'));
if isnan(destinationy), set(handles.txtMessage,'String','Y destination is not a number'); return; end
err = XYAbsolute(xy,destinationx,destinationy);
msg = ['XY Absolute ' num2str(destinationx) ' ' num2str(destinationy) ', error = ' num2str(err)];
set(handles.txtMessage,'String',msg);


% --- Executes on button press in btnMoveRel.
function btnMoveRel_Callback(hObject, eventdata, handles)
% hObject    handle to btnMoveRel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
travelx = str2double(get(handles.txtMoveRelX,'String'));
if isnan(travelx), set(handles.txtMessage,'String','X distance is not a number'); return; end
travely = str2double(get(handles.txtMoveRelY,'String'));
if isnan(travely), set(handles.txtMessage,'String','Y distance is not a number'); return; end
err = XYRelative(xy,travelx,travely);
msg = ['XY Relative ' num2str(travelx) ' ' num2str(travely) ', error = ' num2str(err)];
set(handles.txtMessage,'String',msg);



function txtMoveAbsX_Callback(hObject, eventdata, handles)
% hObject    handle to txtMoveAbsX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMoveAbsX as text
%        str2double(get(hObject,'String')) returns contents of txtMoveAbsX as a double


% --- Executes during object creation, after setting all properties.
function txtMoveAbsX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMoveAbsX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txtMoveAbsY_Callback(hObject, eventdata, handles)
% hObject    handle to txtMoveAbsY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMoveAbsY as text
%        str2double(get(hObject,'String')) returns contents of txtMoveAbsY as a double


% --- Executes during object creation, after setting all properties.
function txtMoveAbsY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMoveAbsY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txtMoveRelX_Callback(hObject, eventdata, handles)
% hObject    handle to txtMoveRelX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMoveRelX as text
%        str2double(get(hObject,'String')) returns contents of txtMoveRelX as a double


% --- Executes during object creation, after setting all properties.
function txtMoveRelX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMoveRelX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txtMoveRelY_Callback(hObject, eventdata, handles)
% hObject    handle to txtMoveRelY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMoveRelY as text
%        str2double(get(hObject,'String')) returns contents of txtMoveRelY as a double


% --- Executes during object creation, after setting all properties.
function txtMoveRelY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMoveRelY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnJog.
function btnJog_Callback(hObject, eventdata, handles)
% hObject    handle to btnJog (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
jogspeedx = str2double(get(handles.txtJogSpeedX,'String'));
if (isnan(jogspeedx)), set(handles.txtMessage,'String','Jog speed X is not a number'); return; end
jogspeedy = str2double(get(handles.txtJogSpeedY,'String'));
if (isnan(jogspeedy)), set(handles.txtMessage,'String','Jog speed Y is not a number'); return; end
err = XYJog(xy, jogspeedx, jogspeedy); 
msg = ['XY Jog ' num2str(jogspeedx) ' ' num2str(jogspeedy) ', error = ' num2str(err)];
set(handles.txtMessage,'String',msg);


function txtJogSpeedX_Callback(hObject, eventdata, handles)
% hObject    handle to txtJogSpeedX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtJogSpeedX as text
%        str2double(get(hObject,'String')) returns contents of txtJogSpeedX as a double


% --- Executes during object creation, after setting all properties.
function txtJogSpeedX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtJogSpeedX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function txtJogSpeedY_Callback(hObject, eventdata, handles)
% hObject    handle to txtJogSpeedY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtJogSpeedY as text
%        str2double(get(hObject,'String')) returns contents of txtJogSpeedY as a double


% --- Executes during object creation, after setting all properties.
function txtJogSpeedY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtJogSpeedY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnStop.
function btnStop_Callback(hObject, eventdata, handles)
% hObject    handle to btnStop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
err = XYStop(xy); 
msg = ['XY Stop, error = ' num2str(err)];
set(handles.txtMessage,'String',msg);


% --- Executes during object creation, after setting all properties.
function txtPosX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtPosX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function txtPosY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtPosY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in btnReadPos.
function btnReadPos_Callback(hObject, eventdata, handles)
% hObject    handle to btnReadPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
[posx, posy, err] = XYPos(xy);
msg = ['XY Read Position, error = ' num2str(err)];
set(handles.txtMessage,'String',msg);
set(handles.txtPosX,'String',num2str(fix(posx*100)/100));
set(handles.txtPosY,'String',num2str(fix(posy*100)/100));


% --- Executes on button press in btnSetOrigin.
function btnSetOrigin_Callback(hObject, eventdata, handles)
% hObject    handle to btnSetOrigin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
err = XYOrigin(xy);
set(handles.txtMessage,'String',['Set origin, error = ' num2str(err)]);


% --- Executes on button press in btnToLimitX.
function btnToLimitX_Callback(hObject, eventdata, handles)
% hObject    handle to btnToLimitX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
speedx = str2double(get(handles.txtToLimXSpeed,'String'));
if isnan(speedx), set(handles.txtMessage,'String','To Limit X speed is not a number'); return; end
set(handles.txtMessage,'String','To Limit X ...');
drawnow
[limitsx,err] = XYToLimitX(xy,speedx);
set(handles.txtMessage,'String',['To Limit X finished, error = ' num2str(err) ', Limit = ' num2str(limitsx)]);


function txtToLimXSpeed_Callback(hObject, eventdata, handles)
% hObject    handle to txtToLimXSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtToLimXSpeed as text
%        str2double(get(hObject,'String')) returns contents of txtToLimXSpeed as a double


% --- Executes during object creation, after setting all properties.
function txtToLimXSpeed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtToLimXSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function txtToLimYSpeed_Callback(hObject, eventdata, handles)
% hObject    handle to txtToLimYSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtToLimYSpeed as text
%        str2double(get(hObject,'String')) returns contents of txtToLimYSpeed as a double


% --- Executes during object creation, after setting all properties.
function txtToLimYSpeed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtToLimYSpeed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnToLimitY.
function btnToLimitY_Callback(hObject, eventdata, handles)
% hObject    handle to btnToLimitY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
speedy = str2double(get(handles.txtToLimYSpeed,'String'));
if isnan(speedy), set(handles.txtMessage,'String','To Limit Y speed is not a number'); return; end
set(handles.txtMessage,'String','To Limit Y ...');
drawnow
[limitsy,err] = XYToLimitY(xy,speedy);
set(handles.txtMessage,'String',['To Limit Y finished, error = ' num2str(err) ', Limit = ' num2str(limitsy)]);


% --- Executes on button press in btnExecuteX.
function btnExecuteX_Callback(hObject, eventdata, handles)
% hObject    handle to btnExecuteX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
cmd = get(handles.txtExecuteX,'String');
set(handles.txtMessage,'String',['Execute on X: ' cmd]);
drawnow
[~, err] = XYExecuteX(xy,cmd); 
set(handles.txtMessage,'String',['Execute on X finished, error = ' num2str(err)]);

function txtExecuteX_Callback(hObject, eventdata, handles)
% hObject    handle to txtExecuteX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtExecuteX as text
%        str2double(get(hObject,'String')) returns contents of txtExecuteX as a double


% --- Executes during object creation, after setting all properties.
function txtExecuteX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtExecuteX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnExecuteY.
function btnExecuteY_Callback(hObject, eventdata, handles)
% hObject    handle to btnExecuteY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
cmd = get(handles.txtExecuteY,'String');
set(handles.txtMessage,'String',['Execute on Y: ' cmd]);
drawnow
[~, err] = XYExecuteY(xy,cmd); 
set(handles.txtMessage,'String',['Execute on Y finished, error = ' num2str(err)]);



function txtExecuteY_Callback(hObject, eventdata, handles)
% hObject    handle to txtExecuteY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtExecuteY as text
%        str2double(get(hObject,'String')) returns contents of txtExecuteY as a double


% --- Executes during object creation, after setting all properties.
function txtExecuteY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtExecuteY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function txtMessage_Callback(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of txtMessage as text
%        str2double(get(hObject,'String')) returns contents of txtMessage as a double


% --- Executes during object creation, after setting all properties.
function txtMessage_CreateFcn(hObject, eventdata, handles)
% hObject    handle to txtMessage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object deletion, before destroying properties.
function figXYStage_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to figXYStage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xy = handles.xy;
if(strcmp(class(xy),'XYStage')) 
    delete(xy);
    clear xy;
    handles.xy = 0;
end
if(handles.PortObjVar == 1)
    s = handles.PortObj;
    if(strcmp(class(s),'serial'))
        [error] = EZStepperCloseSerial(s);
        set(handles.txtMessage,'String',['Close Port, error = ' num2str(error)]);
        handles.PortObjVar = 0;
    end
end
guidata(hObject,handles); % store the changes


